SystemOrganization addCategory: #SeasideAssistants!
SystemOrganization addCategory: #'SeasideAssistants-Tests'!
SystemOrganization addCategory: #'SeasideAssistants-Core'!
SystemOrganization addCategory: #'SeasideAssistants-Platform'!

!WATagBrush methodsFor: '*SeasideAssistants' stamp: 'mb 11/27/2005 19:34'!
with: aBlock
	self document openTag: self tag attributes: attributes renderer: canvas.
	super with: [self within: aBlock].
	self document closeTag: self tag.! !

Object subclass: #WASmartHtmlDocument
	instanceVariableNames: 'document tagStack cssIds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAssistants-Core'!

!WASmartHtmlDocument class methodsFor: 'instance creation' stamp: 'mb 1/27/2006 10:49'!
on: aDocument
	^self new document: aDocument! !

!WASmartHtmlDocument methodsFor: 'duplicate css id' stamp: 'mb 1/27/2006 10:55'!
checkCssIds: attributes renderer: aRenderer
	| id |
	attributes isNil ifTrue: [^self].
	id := (attributes at: 'id' ifAbsent: [^self]) value asSymbol.
	cssIds isNil ifTrue: [cssIds := Set new].
	
	((cssIds includes: id) 
		and: [aRenderer shouldRaiseDuplicateCssIdErrors])
			ifTrue:
				[self error: 'Duplicate id in HTML document']
			ifFalse:
				[cssIds add: id].
! !

!WASmartHtmlDocument methodsFor: 'nested forms' stamp: 'mb 11/27/2005 18:40'!
clearTagStack
	tagStack := OrderedCollection new.! !

!WASmartHtmlDocument methodsFor: 'delegating' stamp: 'mb 1/27/2006 10:36'!
close
	document close! !

!WASmartHtmlDocument methodsFor: 'delegating' stamp: 'mb 1/27/2006 10:38'!
closeTag: aString
	document closeTag: aString.
	self popTag	! !

!WASmartHtmlDocument methodsFor: 'private - accessing' stamp: 'mb 1/27/2006 10:17'!
document: aDocument
	document _ aDocument! !

!WASmartHtmlDocument methodsFor: 'initialization' stamp: 'mb 1/27/2006 10:18'!
initialize
	self clearTagStack.	
	! !

!WASmartHtmlDocument methodsFor: 'delegating' stamp: 'mb 1/27/2006 10:45'!
initializeWithRenderer: aRenderer
	document initializeWithRenderer: aRenderer.
	self clearTagStack.! !

!WASmartHtmlDocument methodsFor: 'delegating' stamp: 'mb 1/27/2006 10:45'!
initializeWithRoot: aRoot
	document initializeWithRoot: aRoot.
	self clearTagStack.! !

!WASmartHtmlDocument methodsFor: 'nested forms' stamp: 'mb 11/27/2005 18:41'!
isWithinTag: aString
	^ tagStack includes: aString! !

!WASmartHtmlDocument methodsFor: 'delegating' stamp: 'mb 1/26/2006 11:25'!
openTag: aString attributes: anAttributes
	self openTag: aString attributes: anAttributes renderer: nil! !

!WASmartHtmlDocument methodsFor: 'delegating' stamp: 'mb 1/27/2006 10:44'!
openTag: aString attributes: anAttributes renderer: aRenderer
	self checkCssIds: anAttributes renderer: aRenderer. "May raise an error"
	document openTag: aString attributes: anAttributes.
	self pushTag: aString.
! !

!WASmartHtmlDocument methodsFor: 'nested forms' stamp: 'mb 11/27/2005 18:45'!
popTag
	^ tagStack removeLast
! !

!WASmartHtmlDocument methodsFor: 'nested forms' stamp: 'mb 1/26/2006 13:40'!
pushTag: aString
	tagStack add: aString
! !

!WASmartHtmlDocument methodsFor: 'delegating' stamp: 'mb 1/27/2006 10:24'!
root
	^document root
! !

!WASmartHtmlDocument methodsFor: 'delegating' stamp: 'mb 1/27/2006 10:24'!
shouldPrintCloseTagFor: aString
	^document shouldPrintCloseTagFor: aString
! !

!WASmartHtmlDocument methodsFor: 'delegating' stamp: 'mb 1/27/2006 10:52'!
stream: aStream
	document stream: aStream
! !

!WASmartHtmlDocument methodsFor: 'delegating' stamp: 'mb 1/27/2006 10:56'!
text: aString
	document text: aString
! !

WARenderCanvas subclass: #WAAssistantsCanvasRenderer
	instanceVariableNames: 'shouldRaiseNestedFormErrors shouldSilentlyDiscardNestedForms shouldRaiseDuplicateCssIdErrors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAssistants-Tests'!

!WAAssistantsCanvasRenderer methodsFor: 'as yet unclassified' stamp: 'mb 1/27/2006 11:20'!
initialize
	super initialize.
	shouldRaiseNestedFormErrors _ super shouldRaiseNestedFormErrors.
	shouldSilentlyDiscardNestedForms _ super shouldSilentlyDiscardNestedForms.
	shouldRaiseDuplicateCssIdErrors _ super shouldRaiseDuplicateCssIdErrors.
! !

!WAAssistantsCanvasRenderer methodsFor: 'accessing' stamp: 'mb 1/27/2006 11:19'!
shouldRaiseDuplicateCssIdErrors
	^shouldRaiseDuplicateCssIdErrors ifNil: [super shouldRaiseDuplicateCssIdErrors]! !

!WAAssistantsCanvasRenderer methodsFor: 'accessing' stamp: 'mb 1/27/2006 11:19'!
shouldRaiseDuplicateCssIdErrors: anObject
	shouldRaiseDuplicateCssIdErrors _ anObject! !

!WAAssistantsCanvasRenderer methodsFor: 'accessing' stamp: 'mb 1/27/2006 11:19'!
shouldRaiseNestedFormErrors
	^shouldRaiseNestedFormErrors ifNil: [super shouldRaiseNestedFormErrors]! !

!WAAssistantsCanvasRenderer methodsFor: 'accessing' stamp: 'mb 1/27/2006 11:20'!
shouldRaiseNestedFormErrors: anObject
	"Set the value of shouldRaiseNestedFormErrors"

	shouldRaiseNestedFormErrors _ anObject! !

!WAAssistantsCanvasRenderer methodsFor: 'accessing' stamp: 'mb 1/27/2006 11:20'!
shouldSilentlyDiscardNestedForms
	^shouldSilentlyDiscardNestedForms ifNil: [super shouldSilentlyDiscardNestedForms]
! !

!WAAssistantsCanvasRenderer methodsFor: 'accessing' stamp: 'mb 1/27/2006 11:20'!
shouldSilentlyDiscardNestedForms: anObject
	"Set the value of shouldSilentlyDiscardNestedForms"

	shouldSilentlyDiscardNestedForms _ anObject! !

!WARenderCanvas methodsFor: '*SeasideAssistants' stamp: 'mb 1/27/2006 11:03'!
shouldRaiseDuplicateCssIdErrors
	"Answer true to raise an error in case of duplicate CSS id in page
	Can be subclassed"
	^false
! !

!WARenderCanvas methodsFor: '*SeasideAssistants' stamp: 'mb 11/27/2005 19:20'!
shouldRaiseNestedFormErrors
	"Answer true to raise an error in case of nested form tags
	Can be subclassed"
	^false
! !

!WARenderCanvas methodsFor: '*SeasideAssistants' stamp: 'mb 11/27/2005 19:20'!
shouldSilentlyDiscardNestedForms
	"Answer true to ignore nested form tags
	Can be subclassed"
	^true
! !

WAComponent subclass: #WADuplicateIdCanvasTest
	instanceVariableNames: 'shouldRaiseDuplicateCssIdErrors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAssistants-Tests'!

!WADuplicateIdCanvasTest methodsFor: 'as yet unclassified' stamp: 'mb 1/27/2006 11:25'!
renderContentOn: html

	self renderDuplicateIdErrorOptionOn: html.	
	html break; break.
	(html span)
		style: 'background: blue; color: yellow';
		id: 'abcdef';
		with: 'This is a span with id="abcdef"'.
	html break; break.
	(html div)
		style: 'border: 1px red solid; width: 25%; background: lightgreen; color: blue';
		id: 'abcdef';
		with: 
			[html 
				text: 'This is a div';
				break;
				text: 'with id="abcdef"']
			
! !

!WADuplicateIdCanvasTest methodsFor: 'as yet unclassified' stamp: 'mb 1/27/2006 11:24'!
renderDuplicateIdErrorOptionOn: html
	html shouldRaiseDuplicateCssIdErrors: shouldRaiseDuplicateCssIdErrors.
	html shouldRaiseDuplicateCssIdErrors
		ifTrue:
			[html text: 'Duplicate id detection currently enabled :'.
			html space.
			(html anchor)
				callback: [shouldRaiseDuplicateCssIdErrors := false];
				text: 'disable it']
		ifFalse:
			[html text: 'Duplicate id detection currently disabled :'.
			html space.
			(html anchor)
				callback: [shouldRaiseDuplicateCssIdErrors := true];
				text: 'enable it'].
! !

!WADuplicateIdCanvasTest methodsFor: 'as yet unclassified' stamp: 'mb 1/27/2006 11:14'!
rendererClass
	^ WAAssistantsCanvasRenderer
! !

WAComponent subclass: #WADuplicateIdTest
	instanceVariableNames: 'shouldRaiseDuplicateCssIdErrors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAssistants-Tests'!

!WADuplicateIdTest methodsFor: 'as yet unclassified' stamp: 'mb 1/26/2006 11:59'!
renderContentOn: html

	self renderDuplicateIdErrorOptionOn: html.	
	html break; break.
	html attributes style: 'background: blue; color: yellow'.
	html spanNamed: 'abcdef' with: 'This is a span with id="abcdef"'.
	html break; break.
	html attributes style: 'border: 1px red solid; width: 25%; background: lightgreen; color: blue'.
	html divNamed: 'abcdef' with: 
			[html 
				text: 'This is a div';
				break;
				text: 'with id="abcdef"']
			
! !

!WADuplicateIdTest methodsFor: 'as yet unclassified' stamp: 'mb 1/26/2006 11:44'!
renderDuplicateIdErrorOptionOn: html
	html renderer shouldRaiseDuplicateCssIdErrors: shouldRaiseDuplicateCssIdErrors.
	html renderer shouldRaiseDuplicateCssIdErrors
		ifTrue:
			[html text: 'Duplicate id detection currently enabled :'.
			html space.
			html anchorWithAction: [shouldRaiseDuplicateCssIdErrors := false] text: 'disable it']
		ifFalse:
			[html text: 'Duplicate id detection currently disabled :'.
			html space.
			html anchorWithAction: [shouldRaiseDuplicateCssIdErrors := true] text: 'enable it'].
! !

!WADuplicateIdTest methodsFor: 'as yet unclassified' stamp: 'mb 1/27/2006 11:12'!
rendererClass
	^WAAssistantsRenderer! !

WAComponent subclass: #WANestedTagCanvasTest
	instanceVariableNames: 'isNested shouldRaiseNestedFormErrors shouldSilentlyDiscardNestedForms name nickName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAssistants-Tests'!

!WANestedTagCanvasTest methodsFor: 'as yet unclassified' stamp: 'mb 11/27/2005 19:12'!
initialize
	isNested := false.
! !

!WANestedTagCanvasTest methodsFor: 'as yet unclassified' stamp: 'mb 1/27/2006 12:01'!
renderContentOn: html 
	self renderNestingStatusOn: html.
	html break.
	self renderOuterFormOn: html.! !

!WANestedTagCanvasTest methodsFor: 'as yet unclassified' stamp: 'mb 1/27/2006 11:14'!
rendererClass
	^ WAAssistantsCanvasRenderer
! !

!WANestedTagCanvasTest methodsFor: 'as yet unclassified' stamp: 'mb 1/27/2006 12:08'!
renderInnerFormContentOn: html 
	| div |
	div := html div.
	isNested 
		ifTrue: [div style: 'border: red solid 1px; width: 90%; margin: 10px; padding: 5px; background: lightblue'].
	div with:
			[html text: 'Enter your nickname'.
			html space.
			(html textInput) 
				value: nickName; 
				callback: [:v | nickName := v].
			html space.
			(html submitButton)
				callback: [self inform: 'Good bye ' , nickName];
				text: 'Say good bye'].
! !

!WANestedTagCanvasTest methodsFor: 'as yet unclassified' stamp: 'mb 1/27/2006 12:03'!
renderInnerForm: aBlock on: html
	isNested 
		ifTrue: [html form with: aBlock]
		ifFalse: aBlock.
! !

!WANestedTagCanvasTest methodsFor: 'as yet unclassified' stamp: 'mb 1/27/2006 12:11'!
renderNestedFormDiscardOptionOn: html
	html shouldSilentlyDiscardNestedForms: shouldSilentlyDiscardNestedForms.
	html shouldSilentlyDiscardNestedForms
		ifTrue:
			[html
				text: 'Silent discard of nested <form> currently enabled :';
				space.
			(html anchor)
				callback: [shouldSilentlyDiscardNestedForms := false];
				text: 'disable it']
		ifFalse:
			[html
				text: 'Silent discard of nested <form> currently disabled :';
				space.
			(html anchor)
				callback: [shouldSilentlyDiscardNestedForms := true];
				text: 'enable it'].
! !

!WANestedTagCanvasTest methodsFor: 'as yet unclassified' stamp: 'mb 1/27/2006 12:10'!
renderNestedFormErrorOptionOn: html
	html shouldRaiseNestedFormErrors: shouldRaiseNestedFormErrors.
	html shouldRaiseNestedFormErrors
		ifTrue:
			[html
				text: 'Nested <form> detection currently enabled :';
				space.
			(html anchor)
				callback: [shouldRaiseNestedFormErrors := false];
				text: 'disable it']
		ifFalse:
			[html
				text: 'Nested <form> detection currently disabled :';
				space.
			(html anchor)
				callback: [shouldRaiseNestedFormErrors := true];
				text: 'enable it'].
! !

!WANestedTagCanvasTest methodsFor: 'as yet unclassified' stamp: 'mb 1/27/2006 12:13'!
renderNestingStatusOn: html 
	isNested 
		ifTrue: 
			[(html anchor)
				callback: [isNested := false];
				text: 'Suppress <form> nesting'.
			html
				space;
				space;
				bold: 'Note:';
				space;
				text: 'by default, nested <form> are silently discarded'.
			(html div)
				style: 'margin: 1em 0 0 5em';
				with:
					[self renderNestedFormErrorOptionOn: html.	
					html break.
					self renderNestedFormDiscardOptionOn: html]]
		ifFalse: 
			[(html anchor)
				callback: [isNested := true];
				text: 'Add <form> nesting'].
! !

!WANestedTagCanvasTest methodsFor: 'as yet unclassified' stamp: 'mb 1/27/2006 12:08'!
renderOuterFormOn: html
	(html form)
		defaultAction: [self inform: 'You do not like to click with a mouse, do you ?'];
		with: 
				[(html div)
					style: 'border: green solid 1px; width: 50%; padding: 5px; background: lightyellow';
					with: 
							[html text: 'Enter your name'.
							html space.
							(html textInput)
								value: name;
								callback: [:v | name := v].
							html space.
							(html submitButton)
								callback: [self inform: 'Hello ' , name];
								text: 'Say hello'.
							html break.
							self renderInnerForm: [self renderInnerFormContentOn: html] on: html]]
! !

WAComponent subclass: #WANestedTagTest
	instanceVariableNames: 'isNested shouldRaiseNestedFormErrors shouldSilentlyDiscardNestedForms name nickName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAssistants-Tests'!

!WANestedTagTest methodsFor: 'initialization' stamp: 'mb 11/4/2005 10:27'!
initialize
	isNested := false.
	nickName := String new.
	name := String new.
! !

!WANestedTagTest methodsFor: 'rendering' stamp: 'mb 1/27/2006 12:00'!
renderContentOn: html
	self renderNestingStatusOn: html.
	html break; break.
	self renderOuterFormOn: html! !

!WANestedTagTest methodsFor: 'rendering' stamp: 'mb 1/27/2006 11:10'!
rendererClass
	^WAAssistantsRenderer! !

!WANestedTagTest methodsFor: 'rendering' stamp: 'mb 1/27/2006 11:51'!
renderInnerFormContentOn: html 
	isNested 
		ifTrue: [html attributes style: 'border: red solid 1px; width: 90%; margin: 10px; padding: 5px; background: lightblue'].
	html div: 
			[html
				text: 'Enter your nickname';
				space;
				textInputWithValue: nickName
					callback: [:v | nickName := v];
				space;
				submitButtonWithAction: [self inform: 'Good bye ' , nickName]
					text: 'Say good bye']! !

!WANestedTagTest methodsFor: 'rendering' stamp: 'mb 1/27/2006 11:46'!
renderInnerForm: aBlock on: html
	isNested 
		ifTrue: [html form: aBlock]
		ifFalse: aBlock.
! !

!WANestedTagTest methodsFor: 'rendering' stamp: 'mb 1/27/2006 11:51'!
renderNestedFormDiscardOptionOn: html
	html renderer shouldSilentlyDiscardNestedForms: shouldSilentlyDiscardNestedForms.
	html renderer shouldSilentlyDiscardNestedForms
		ifTrue:
			[html
				text: 'Silent discard of nested <form> currently enabled :';
				space;
				anchorWithAction: [shouldSilentlyDiscardNestedForms := false]
					text: 'disable it']
		ifFalse:
			[html
				text: 'Silent discard of nested <form> currently disabled :';
				space;
				anchorWithAction: [shouldSilentlyDiscardNestedForms := true]
					text: 'enable it'].
! !

!WANestedTagTest methodsFor: 'rendering' stamp: 'mb 1/27/2006 11:52'!
renderNestedFormErrorOptionOn: html
	html renderer shouldRaiseNestedFormErrors: shouldRaiseNestedFormErrors.
	html renderer shouldRaiseNestedFormErrors
		ifTrue:
			[html
				text: 'Nested <form> detection currently enabled :';
				space;
				anchorWithAction: [shouldRaiseNestedFormErrors := false]
					text: 'disable it']
		ifFalse:
			[html
				text: 'Nested <form> detection currently disabled :';
				space;
				anchorWithAction: [shouldRaiseNestedFormErrors := true]
					text: 'enable it'].
! !

!WANestedTagTest methodsFor: 'rendering' stamp: 'mb 1/27/2006 11:58'!
renderNestingStatusOn: html
	isNested 
		ifTrue: 
			[html
				anchorWithAction: [isNested := false] text: 'Suppress <form> nesting';
				space;
				space;
				bold: 'Note:';
				space;
				text: 'By default, nested <form> are silently discarded';
				break;
				style: 'margin: 1em 0 0 5em';
				div:
					[self renderNestedFormErrorOptionOn: html.	
					html break.
					self renderNestedFormDiscardOptionOn: html]]
		ifFalse: 
			[html
				anchorWithAction: [isNested := true]
					text: 'Add <form> nesting'].
! !

!WANestedTagTest methodsFor: 'rendering' stamp: 'mb 1/27/2006 11:54'!
renderOuterFormOn: html
	html form: 
		[html attributes style: 'border: green solid 1px; width: 50%; padding: 5px; background: lightyellow'.
		html div: 
			[html
				text: 'Enter your name';
				space;
				textInputWithValue: name 
					callback: [:v | name := v];
				space;
				submitButtonWithAction: [self inform: 'Hello ' , name]
					text: 'Say hello';
				break.
			self
				renderInnerForm: [self renderInnerFormContentOn: html]
				on: html]]! !

WAFrameComponent subclass: #WAMoreTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAssistants-Tests'!

!WAMoreTests methodsFor: 'as yet unclassified' stamp: 'mb 1/27/2006 11:15'!
initialize
	self contents:
	 (WASimpleNavigation new
		add: WAImageTest new label: 'Images';
		add: WAHomeTest new label: 'Home';
		add: WACacheTest new label: 'Cache';
		add: WADefaultFormTest new label: 'Default Form';
		add: WALinkSubmitTest new label: 'Submit';
		add: WANestedTagTest new label: 'Nested forms';
		add: WANestedTagCanvasTest new label: 'Nested forms (canvas)';
		add: WADuplicateIdTest new label: 'Duplicate id=';
		add: WADuplicateIdCanvasTest new label: 'Duplicate id= (canvas)';
		yourself)


! !

!WAMoreTests methodsFor: 'as yet unclassified' stamp: 'mb 11/27/2005 19:11'!
renderContentOn: html
	html heading: 'He !! Another row of tests !!' level: 2.
	html render: contents.
! !

WAHtmlRenderer subclass: #WAAssistantsRenderer
	instanceVariableNames: 'shouldRaiseNestedFormErrors shouldSilentlyDiscardNestedForms shouldRaiseDuplicateCssIdErrors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAssistants-Tests'!

!WAAssistantsRenderer methodsFor: 'initialize-release' stamp: 'mb 1/27/2006 11:12'!
initialize
	super initialize.
	shouldRaiseNestedFormErrors _ super shouldRaiseNestedFormErrors.
	shouldSilentlyDiscardNestedForms _ super shouldSilentlyDiscardNestedForms.
	shouldRaiseDuplicateCssIdErrors _ super shouldRaiseDuplicateCssIdErrors.
! !

!WAAssistantsRenderer methodsFor: 'accessing' stamp: 'mb 1/27/2006 11:10'!
shouldRaiseDuplicateCssIdErrors
	^shouldRaiseDuplicateCssIdErrors ifNil: [super shouldRaiseDuplicateCssIdErrors]! !

!WAAssistantsRenderer methodsFor: 'accessing' stamp: 'mb 1/27/2006 11:11'!
shouldRaiseDuplicateCssIdErrors: anObject
	shouldRaiseDuplicateCssIdErrors _ anObject! !

!WAAssistantsRenderer methodsFor: 'accessing' stamp: 'mb 11/4/2005 10:07'!
shouldRaiseNestedFormErrors
	^shouldRaiseNestedFormErrors ifNil: [super shouldRaiseNestedFormErrors]! !

!WAAssistantsRenderer methodsFor: 'accessing' stamp: 'mb 11/4/2005 09:58'!
shouldRaiseNestedFormErrors: anObject
	"Set the value of shouldRaiseNestedFormErrors"

	shouldRaiseNestedFormErrors _ anObject! !

!WAAssistantsRenderer methodsFor: 'accessing' stamp: 'mb 11/4/2005 10:06'!
shouldSilentlyDiscardNestedForms
	^shouldSilentlyDiscardNestedForms ifNil: [super shouldSilentlyDiscardNestedForms]
! !

!WAAssistantsRenderer methodsFor: 'accessing' stamp: 'mb 11/4/2005 09:58'!
shouldSilentlyDiscardNestedForms: anObject
	"Set the value of shouldSilentlyDiscardNestedForms"

	shouldSilentlyDiscardNestedForms _ anObject! !

!WAHtmlRenderer methodsFor: '*SeasideAssistants' stamp: 'mb 11/27/2005 18:54'!
form: aBlock 
	((self document isWithinTag: 'form') not or: 
			[self shouldRaiseNestedFormErrors not 
				and: [self shouldSilentlyDiscardNestedForms not]]) 
		ifTrue: 
			[self 
				formWithMethod: 'post'
				action: context actionUrl urlString
				do: 
					[self div: 
							[context actionUrl parameters keysAndValuesDo: 
									[:k :v | 
									self 
										inputWithType: 'hidden'
										named: k
										value: v].
							aBlock value]]]
		ifFalse: 
			[self shouldRaiseNestedFormErrors 
				ifTrue: [self error: 'Nested <form> !!']
				ifFalse: [aBlock value]]
! !

!WAHtmlRenderer methodsFor: '*SeasideAssistants' stamp: 'mb 11/27/2005 18:56'!
shouldRaiseDuplicateCssIdErrors
	"Answer true to raise an error in case of duplicate CSS id in page
	Can be subclassed"
	^false
! !

!WAHtmlRenderer methodsFor: '*SeasideAssistants' stamp: 'mb 11/27/2005 19:48'!
shouldRaiseNestedFormErrors
	"Answer true to raise an error in case of nested form tags
	Can be subclassed"
	^false
! !

!WAHtmlRenderer methodsFor: '*SeasideAssistants' stamp: 'mb 11/27/2005 18:57'!
shouldSilentlyDiscardNestedForms
	"Answer true to ignore nested form tags
	Can be subclassed"
	^true
! !

!WAAllTests methodsFor: '*SeasideAssistants' stamp: 'mb 11/27/2005 10:26'!
initialize
	self contents:
	 (WASimpleNavigation new
		add: WAInputTest new label: 'Input';
		add: WAHtmlTest new label: 'Html';
		add: WAEncodingTest new label: 'Encoding';
		add: WAErrorTest new label: 'Error';
		add: WAExceptionTest new label: 'Exception';
		add: WAClosureTest new label: 'Closure';
		add: WATransactionTest new label: 'Transaction';
		add: WAUploadTest new label: 'Upload';
		add: (WAParentTest new parent: self) label: 'Parent';
		add:  WAPathTest new label: 'Path';
		add: WATaskTest new label: 'Task';
		add: WACookieTest new label: 'Cookies';
		add: WACallbackTest new label: 'Callbacks';
		add: WACanvasTest new label: 'Canvas';
		add: WAMoreTests new label: 'More...';
		yourself)
! !

!WAPrettyPrintedDocument class methodsFor: '*SeasideAssistants' stamp: 'mb 1/27/2006 10:35'!
renderer: aRenderer
	^ self newWithSmartDecoration initializeWithRenderer: aRenderer! !

!WAScriptTag methodsFor: '*SeasideAssistants' stamp: 'mb 1/5/2006 14:05'!
with: aBlock
	isClosed := true.
	self attributes at: 'type' ifAbsentPut: ['text/javascript'].
	self document openTag: self tag attributes: attributes renderer: self.
	canvas html: aBlock.
	self document closeTag: self tag.
! !

!WAHtmlDocument class methodsFor: '*SeasideAssistants' stamp: 'mb 1/27/2006 10:34'!
newWithSmartDecoration
	^WASmartHtmlDocument on: self basicNew! !

!WAHtmlDocument class methodsFor: '*SeasideAssistants' stamp: 'mb 1/27/2006 10:34'!
root: anHtmlRoot
	^self newWithSmartDecoration initializeWithRoot: anHtmlRoot ! !

!WAHtmlCanvas methodsFor: '*SeasideAssistants' stamp: 'mb 11/27/2005 17:31'!
tag: aString
	aString = 'form' ifTrue: [^self form].
	^ self brush: (WAGenericTag tag: aString)! !

PackageInfo subclass: #SeasideAssistantsVWInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAssistants-Platform'!

!SeasideAssistantsVWInfo class methodsFor: 'as yet unclassified' stamp: 'mb 1/26/2006 11:08'!
fileOutVW5
	VW5PackageExporter fileOutPackage: self default on: (FileStream forceNewFileNamed: 'SeasideAssistantsVW5.st')! !

!SeasideAssistantsVWInfo methodsFor: 'as yet unclassified' stamp: 'mb 1/26/2006 11:12'!
externalName
	^ 'SeasideAssistants'! !

!SeasideAssistantsVWInfo methodsFor: 'as yet unclassified' stamp: 'mb 1/26/2006 11:10'!
ignoredCategories
	^ #('Platform')! !

!SeasideAssistantsVWInfo methodsFor: 'as yet unclassified' stamp: 'mb 1/26/2006 11:14'!
includesSystemCategory: aString
	^ (aString beginsWith: 'SeasideAssistants-') and: [(self ignoredCategories includes: (aString copyAfter: $-)) not]! !

!SeasideAssistantsVWInfo methodsFor: 'as yet unclassified' stamp: 'mb 1/26/2006 11:14'!
isYourClassExtension: aString
	^ (self category: aString asLowercase matches: '*seasideassistants')
		and: [(aString endsWith: 'squeak') not]! !

!SeasideAssistantsVWInfo methodsFor: 'as yet unclassified' stamp: 'mb 1/26/2006 11:17'!
namespace
	^'Seaside'! !

!SeasideAssistantsVWInfo methodsFor: 'as yet unclassified' stamp: 'mb 1/26/2006 11:10'!
needsNamespace
	^false! !

!WAFormTag methodsFor: '*SeasideAssistants' stamp: 'mb 11/27/2005 17:23'!
isWithinForm

	^ self document isWithinTag: self tag! !

!WAFormTag methodsFor: '*SeasideAssistants' stamp: 'mb 11/27/2005 17:24'!
with: aBlock 
	(self isWithinForm not or: 
			[canvas shouldRaiseNestedFormErrors not 
				and: [canvas shouldSilentlyDiscardNestedForms not]]) 
		ifTrue: [super with: aBlock]
		ifFalse: 
			[canvas shouldRaiseNestedFormErrors 
				ifTrue: [self error: 'Nested <form> !!']
				ifFalse: 
					[canvas nest: aBlock.
					isClosed := true]]! !

!WAAbstractHtmlBuilder methodsFor: '*SeasideAssistants' stamp: 'mb 11/27/2005 10:23'!
openTag: aString
	self document openTag: aString attributes: self attributes renderer: self.
	attributeBuffer _ nil.
! !
